"""add Site create  workflow.

Revision ID: 21e7bb0e5cad
Revises: 60d340427471
Create Date: 2023-05-04 09:00:36.433715

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = '21e7bb0e5cad'
down_revision = '60d340427471'
branch_labels = None
depends_on = None


from orchestrator.migrations.helpers import create_workflow, delete_workflow

new_workflows = [
    {
        "name": "create_site",
        "target": "CREATE",
        "description": "Create Site",
        "product_type": "Site"
    }
]


def upgrade() -> None:
    conn = op.get_bind()
    for workflow in new_workflows:
        create_workflow(conn, workflow)


def downgrade() -> None:
    conn = op.get_bind()
    for workflow in new_workflows:
        delete_workflow(conn, workflow["name"])
